/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bonusgroup.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.guosen.bonusgroup.vo.SimpleBonusGroupVO;
import org.springblade.modules.guosen.bonusscene.entity.BonusScene;
import org.springblade.modules.guosen.bonusscene.vo.SimpleBonusSceneVO;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bonusgroup.entity.BonusGroup;
import org.springblade.modules.guosen.bonusgroup.vo.BonusGroupVO;
import org.springblade.modules.guosen.bonusgroup.wrapper.BonusGroupWrapper;
import org.springblade.modules.guosen.bonusgroup.service.IBonusGroupService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 分润组 控制器
 *
 * @author BladeX
 * @since 2021-11-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bonus-group/bonusgroup")
@Api(value = "分润组", tags = "分润组接口")
public class BonusGroupController extends BladeController {

	private final IBonusGroupService bonusGroupService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bonusGroup")
	public R<BonusGroupVO> detail(BonusGroup bonusGroup) {
		BonusGroup detail = bonusGroupService.getOne(Condition.getQueryWrapper(bonusGroup));
		return R.data(BonusGroupWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 分润组
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bonusGroup")
	public R<IPage<BonusGroupVO>> list(BonusGroup bonusGroup, Query query) {
		IPage<BonusGroup> pages = bonusGroupService.page(Condition.getPage(query), Condition.getQueryWrapper(bonusGroup));
		return R.data(BonusGroupWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 分润组
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bonusGroup")
	public R<IPage<BonusGroupVO>> page(BonusGroupVO bonusGroup, Query query) {
		IPage<BonusGroupVO> pages = bonusGroupService.selectBonusGroupPage(Condition.getPage(query), bonusGroup);
		return R.data(pages);
	}

	/**
	 * 新增 分润组
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bonusGroup")
	public R save(@Valid @RequestBody BonusGroup bonusGroup) {
		return R.status(bonusGroupService.save(bonusGroup));
	}

	/**
	 * 修改 分润组
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bonusGroup")
	public R update(@Valid @RequestBody BonusGroup bonusGroup) {
		return R.status(bonusGroupService.updateById(bonusGroup));
	}

	/**
	 * 新增或修改 分润组
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bonusGroup")
	public R submit(@Valid @RequestBody BonusGroup bonusGroup) {
		return R.status(bonusGroupService.saveOrUpdate(bonusGroup));
	}

	
	/**
	 * 删除 分润组
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bonusGroupService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 根据条件下拉获取分润商户list
	 * @param bonusGroup
	 * @return
	 */
	@GetMapping(value = "/listBonusGroup")
	@ApiOperationSupport(order = 8)
	public R<List<SimpleBonusGroupVO>> listBonusScene(BonusGroup bonusGroup){
		LambdaQueryWrapper<BonusGroup> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		if(StringUtil.isNotBlank(bonusGroup.getGroupName())){
			lambdaQueryWrapper.like(BonusGroup::getGroupName, bonusGroup.getGroupName());
		}
		if(bonusGroup.getBounsSceneId() != null){
			lambdaQueryWrapper.eq(BonusGroup::getBounsSceneId, bonusGroup.getBounsSceneId());
		}
		List<BonusGroup> list = this.bonusGroupService.list(lambdaQueryWrapper);
		List<SimpleBonusGroupVO> voList = list.stream()
						.map(item -> {
							SimpleBonusGroupVO vo = new SimpleBonusGroupVO();
							vo.setId(item.getId());
							vo.setName(item.getGroupName());
							return vo;
						}).collect(Collectors.toList());
		return R.data(voList);
	}

	
}
